summaryrefslogtreecommitdiff
path: root/sofort
diff options
context:
space:
mode:
authormidipix <writeonce@midipix.org>2018-12-19 10:04:45 -0500
committermidipix <writeonce@midipix.org>2018-12-24 19:22:33 -0500
commit2e11710931ed56d226ca154f9da73c347d9f7cdc (patch)
tree894d74f6b56c46d74caaf131a883c775acfb3836 /sofort
parent01e6093534b73c1fc9a034a0054de43d3cd5b067 (diff)
downloadsofort-2e11710931ed56d226ca154f9da73c347d9f7cdc.tar.bz2
sofort-2e11710931ed56d226ca154f9da73c347d9f7cdc.tar.xz
cfgtest.sh: added cfgtest_decl_presence.
Diffstat (limited to 'sofort')
-rw-r--r--sofort/cfgtest.sh33
1 files changed, 33 insertions, 0 deletions
diff --git a/sofort/cfgtest.sh b/sofort/cfgtest.sh
index bd661c0..57aca7c 100644
--- a/sofort/cfgtest.sh
+++ b/sofort/cfgtest.sh
@@ -157,6 +157,39 @@ cfgtest_interface_presence()
return 0
}
+
+cfgtest_decl_presence()
+{
+ mb_internal_cflags=''
+
+ for mb_header in $mb_cfgtest_headers; do
+ mb_internal_cflags="$mb_internal_cflags --include=$mb_header"
+ done
+
+ printf 'void * any = (void *)%s;' "$@" \
+ | $mb_cfgtest_cc -S -xc - -o - \
+ $mb_cfgtest_cflags \
+ $mb_internal_cflags \
+ > /dev/null 2>/dev/null \
+ || return 1
+
+ # does the argument solely consist of the macro or enum member name?
+ mb_internal_str=$(printf '%s' "$@" | tr -d '[a-z][A-Z][0-9][_]')
+
+ if [ -n "$mb_internal_str" ]; then
+ return 0
+ fi
+
+ mb_internal_str=$(printf '%s%s' '-DHAVE_DECL_' "$@" \
+ | sed -e 's/\./_/g' \
+ | tr "[:lower:]" "[:upper:]")
+
+ cfgtest_cflags_append "$mb_internal_str"
+
+ return 0
+}
+
+
cfgtest_library_presence()
{
printf 'int main(void){return 0;}' \